%global version_major 8
%global version_minor 0
%global version_micro 36
%global meadalpha %{nil}
%global meadrel %{nil}
%global commitid a2e61a02d9cd894da4a0661640fda065a3ab7d6d
%global serial 44

# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _jarsign_opts --nocopy --skip=%{basedir} --skip=%{bindir} --skip=%{_javadir} 

%define section free

# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root

%bcond_without zips
%bcond_with ws
%bcond_without repolib

%define with_signing 0

%define artifactversion %{version}.redhat-%{serial}
%define repodir %{_javadir}/repository.jboss.com/apache-tomcat/%{artifactversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define major_version 8
%define minor_version 0
%define micro_version 36
%define packdname apache-tomcat-%{version}-src
%define elspec 2.2
%define elspecalt 2_2
%define jspspec 2.3
%define servletspec 3.1
%define tcuid 91
%define ecjrev 4.4.2

# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/2.3/
%define basedir %{_var}/lib/%{name}
%define appdir %{basedir}/webapps
%define homedir %{_datadir}/%{name}
%define bindir %{homedir}/bin
%define confdir %{_sysconfdir}/%{name}
%define libdir %{_javadir}/%{name}
%define logdir %{_var}/log/%{name}
%define cachedir %{_var}/cache/%{name}
%define tempdir %{cachedir}/temp
%define workdir %{cachedir}/work
%define _initrddir %{_sysconfdir}/rc.d/init.d
%define javasigneddir %{_datadir}/java-signed
%define javaversion 1.7.0

%if 0%{?rhel} <= 6
%define _file_context_file %{_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts
%define _file_context_file_pre %{_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts.pre
%{!?_selinux_policy_version: %global _selinux_policy_version %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' %{_datadir}/selinux/devel/policyhelp 2>/dev/null)}
%endif

Name: tomcat8
Epoch: 0
Version: %{major_version}.%{minor_version}.%{micro_version}
Release: %{serial}%{?dist}
Summary: Apache Servlet/JSP Engine, RI for Servlet %{servletspec}/JSP %{jspspec} API
Group: Networking/Daemons
License: ASL 2.0
URL: http://tomcat.apache.org/

# Repository name changed; now it's tomcat80 instead of tomcat8
Source0: %{name}0-%{commitid}.tar.gz
Source1: %{name}-%{major_version}.%{minor_version}.conf
Source3: %{name}-%{major_version}.%{minor_version}.sysconfig
Source5: %{name}-%{major_version}.%{minor_version}.logrotate
Source6: %{name}-%{major_version}.%{minor_version}-digest.script
Source7: %{name}-%{major_version}.%{minor_version}-tool-wrapper.script
Source9: %{name}-%{major_version}.%{minor_version}-log4j.properties
Source10: %{name}-component-info.xml
# for SELinux
Source12: %{name}.if
# This version must match the default
# version in build.properties.default
Source14: commons-logging-1.1.3-src.tar.gz
Source15: README.CVE-2007-1355.%{name}
Source16: tomcat-storeconfig.pom
#Source11: %{name}-7.0.policy

# systemd doesn't exist in versions before rhel7
%if 0%{?rhel} >= 7
Source4: %{name}-%{major_version}.%{minor_version}.el7.wrapper
Source11: %{name}.el7.te
Source13: %{name}.el7.fc
Source17:      %{name}-%{major_version}.%{minor_version}.service
Source18:      %{name}-functions
Source19:      %{name}-preamble
Source20:      %{name}-server
Source21:      %{name}-named.service
Source22:      %{name}-%{major_version}.%{minor_version}-jsvc.service
%else
Source11: %{name}.el6.te
Source13: %{name}.el6.fc
Source2: %{name}-%{major_version}.%{minor_version}.init
Source4: %{name}-%{major_version}.%{minor_version}.el6.wrapper
Source23: %{name}-%{major_version}.%{minor_version}-jsvc.el6.wrapper
%endif

# The location of a JAR changed between el6 and el7,
# so there are two patches...
%if 0%{?rhel} >= 7
Patch0: %{name}-8.0-catalina-policy.el7.patch
%else
Patch0: %{name}-8.0-catalina-policy.el6.patch
%endif

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch
BuildRequires: zip

%if 0%{?rhel} == 6
BuildRequires: java7-devel >= 0:1.7.0
%else
BuildRequires: java-devel >= 0:1.7.0
%endif
%if 0%{?rhel} == 6
BuildRequires: ecj-eap6
%else 
BuildRequires: eap6-ecj
%endif
BuildRequires: ant >= 0:1.9.2
BuildRequires: findutils
BuildRequires: apache-commons-collections-eap6 >= 0:3.2.1-18
BuildRequires: jbcs-httpd24-apache-commons-daemon
%if %with ws
BuildRequires: axis >= 0:1.1
BuildRequires: wsdl4j >= 0:1.6.1
%endif

BuildRequires: jpackage-utils >= 0:1.7.0

BuildRequires: log4j-eap6 
BuildRequires: avalon-framework
#BuildRequires: avalon-logkit >=  0:1.2-8.2.1
BuildRequires: avalon-logkit
%if %with repolib
# TODO: Examine whether or not these are still necessary after dropping mvn-jpp
%if 0%{?rhel} == 6
BuildRequires:  maven
BuildRequires:  maven-deploy-plugin
BuildRequires:  apache-commons-parent
BuildRequires:  apache-parent >= 0:7
%endif
%endif

BuildRequires: jboss-parent

Requires(pre): shadow-utils
Requires(pre): shadow-utils
Requires: jbcs-httpd24-apache-commons-daemon
#Requires: apache-commons-logging-eap6
Requires: java >= 1.7.0
Requires: jpackage-utils
Requires: procps
Requires: %{name}-lib = %{epoch}:%{version}-%{release}
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): /lib/lsb/init-functions
Requires(preun): /lib/lsb/init-functions
Requires(post,postun): jpackage-utils

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License version 2.0. Tomcat is intended
to be a collaboration of the best-of-breed developers from around the world.

%package admin-webapps
Group: System Environment/Applications
Summary: The host-manager and manager web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description admin-webapps
The host-manager and manager web applications for Apache Tomcat.

%if %with ws
%package ws
Group: Internet/WWW/Dynamic Content
Summary: Web Services (JSR 109) support for Apache Tomcat
Requires: axis >= 0:1.1
Requires: wsdl4j >= 0:1.6.1

%description ws
Tomcat provides factories for JSR 109 which may be used to resolve web services
references.
%endif

%package docs-webapp
Group: System Environment/Applications
Summary: The docs web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description docs-webapp
The docs web application for Apache Tomcat.

%package el-%{elspec}-api
Summary: Expression Language v%{elspec} API
Group: Development/Libraries/Java
Provides: el_%{elspecalt}_api = %{epoch}:%{version}-%{release}
Provides: el_api = 0:%{elspec}
Obsoletes: el_1_0_api < %{epoch}:%{version}-%{release}
Obsoletes: el_api < %{epoch}:%{elspec}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires: jpackage-utils

Requires(preun):  %{_sbindir}/update-alternatives
Requires(post):  %{_sbindir}/update-alternatives

%description el-%{elspec}-api
Expression Language %{elspec} 

%package javadoc
Group: Documentation
Summary: Javadoc generated documentation for Apache Tomcat
Requires(pre): coreutils

%description javadoc
Javadoc generated documentation for Apache Tomcat.

%package jsvc
Group: System Environment/Daemons
Summary: Apache jsvc wrapper for Apache Tomcat as separate service
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: jbcs-httpd24-apache-commons-daemon-jsvc

%description jsvc
Systemd service to start tomcat with jsvc,
which allows tomcat to perform some privileged operations
(e.g. bind to a port < 1024) and then switch identity to a non-privileged user.

%package jsp-%{jspspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat JSP API implementation classes
Provides: jsp = %{jspspec}
Provides: jsp22
Obsoletes: jsp21
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires: jpackage-utils

Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives

%description jsp-%{jspspec}-api
Apache Tomcat JSP API implementation classes.

%package log4j
Group: Internet/WWW/Dynamic Content
Summary: Log4J support for Apache Tomcat
# The jar is copied over instead of linking because it is in base
Requires: log4j-eap6
#Requires: apache-commons-logging-eap6

%description log4j
Log4J support for Apache Tomcat.

%package lib
Group: Development/Compilers
Summary: Libraries needed to run the Tomcat Web container
Provides: %{name}-annotations-api = %{epoch}:%{version}-%{release}
Provides: %{name}-api = %{epoch}:%{version}-%{release}
Provides: %{name}-catalina-ant = %{epoch}:%{version}-%{release}
Provides: %{name}-catalina = %{epoch}:%{version}-%{release}
Provides: %{name}-coyote = %{epoch}:%{version}-%{release}
Provides: %{name}-i18n-es = %{epoch}:%{version}-%{release}
Provides: %{name}-i18n-fr = %{epoch}:%{version}-%{release}
Provides: %{name}-i18n-ja = %{epoch}:%{version}-%{release}
Provides: %{name}-jasper-el = %{epoch}:%{version}-%{release}
Provides: %{name}-jasper = %{epoch}:%{version}-%{release}
Provides: %{name}-jdbc = %{epoch}:%{version}-%{release}
Provides: %{name}-juli = %{epoch}:%{version}-%{release}
Provides: %{name}-util = %{epoch}:%{version}-%{release}
Provides: %{name}-websockets = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires: jpackage-utils
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}

%if 0%{?rhel} == 6
Requires: ecj-eap6
%else
Requires: eap6-ecj
%endif

Requires: apache-commons-collections-eap6 >= 0:3.2.1-18
Requires(preun): coreutils

%description lib
Libraries needed to run the Tomcat Web container.

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat Servlet API implementation classes
Provides: servlet = %{servletspec}
Provides: servlet6
#Provides: servlet25
Provides: servlet31
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires: jpackage-utils

Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives

%description servlet-%{servletspec}-api
Apache Tomcat Servlet API implementation classes.

%package webapps
Group: System Environment/Applications
Summary: The ROOT web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description webapps
The ROOT web application for Apache Tomcat.

%if %with zips
%package zip
Summary:     Container for the zipped distribution of tomcat8
Group:       Development

%description zip
Container for the zipped distribution of tomcat8

%package src-zip
Summary:     Container for the sources
Group:       Development

%description src-zip
Container for the sources
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package maven-devel
Summary:     Container for Maven components and artifacts
Group:       Development
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-annotations-api = %{epoch}:%{version}-%{release}
Requires: %{name}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-catalina-ant = %{epoch}:%{version}-%{release}
Requires: %{name}-catalina = %{epoch}:%{version}-%{release}
Requires: %{name}-coyote = %{epoch}:%{version}-%{release}
Requires: %{name}-i18n-es = %{epoch}:%{version}-%{release}
Requires: %{name}-i18n-fr = %{epoch}:%{version}-%{release}
Requires: %{name}-i18n-ja = %{epoch}:%{version}-%{release}
Requires: %{name}-jasper-el = %{epoch}:%{version}-%{release}
Requires: %{name}-jasper = %{epoch}:%{version}-%{release}
Requires: %{name}-jdbc = %{epoch}:%{version}-%{release}
Requires: %{name}-juli = %{epoch}:%{version}-%{release}
Requires: %{name}-util = %{epoch}:%{version}-%{release}
Requires: %{name}-websockets = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires: jpackage-utils
Requires(preun): coreutils

%description maven-devel
Container for tomcat maven components and artifacts

%package selinux
Summary:        Selinux policy for tomcat8
Group:          System Environment/Daemons
BuildRequires:  selinux-policy, selinux-policy-devel
%if 0%{?rhel} == 6
BuildRequires:  /usr/share/selinux/devel/policyhelp
%endif

%if "%{_selinux_policy_version}" != ""
Requires(pre):      selinux-policy-targeted >= %{_selinux_policy_version}
Requires(post):     selinux-policy-targeted >= %{_selinux_policy_version}
Requires(postun):   selinux-policy-targeted >= %{_selinux_policy_version}
%endif
Requires:           %{name} = %{version}-%{release}
Requires(pre):      policycoreutils, policycoreutils-python, libselinux-utils
Requires(post):     policycoreutils, policycoreutils-python, libselinux-utils
Requires(postun):   policycoreutils, policycoreutils-python, libselinux-utils

%description selinux
This is the selinux policy for tomcat8.

%prep
echo Prep Phase
%setup -q -c -T -a 0

# updating the tomcat tar struture requires some changes after untar
mv %{name}0-%{commitid} %{packdname}

%{_bindir}/find . -type f -name "*.[jw]ar" -o -type f -name "*.bat" -o -type f -name "*.pdf" | %{_bindir}/xargs -t -I{} %{__rm} {}
pushd %{packdname}

# Apply the policy patch
%patch0 -p0

%{__rm} -f ./res/maven/tomcat-catalina-ha.pom
%{__rm} -f ./res/maven/tomcat-tribes.pom
%{__rm} -f ./res/maven/tomcat-catalina-jmx-remote.pom

# Temporary. 
%{__cp} %{SOURCE16} ./res/maven/tomcat-storeconfig.pom

%{__sed} -i -e 's/@MAVEN.DEPLOY.VERSION@/%{artifactversion}/g' ./res/maven/*.pom

%{__mkdir_p} output/extras
%{__cp} %{SOURCE14} .
%if %with ws
%{__mkdir_p} output/extras/webservices
%{__ln_s} $(build-classpath axis/jaxrpc) output/extras/webservices/jaxrpc.jar
%{__ln_s} $(build-classpath wsdl4j/wsdl4j16) output/extras/webservices/wsdl4j.jar
%endif
popd

%{__mkdir_p} selinux
%{__cp} -p %{SOURCE11} ./selinux/tomcat8.te
%{__cp} -p %{SOURCE12} ./selinux/
%{__cp} -p %{SOURCE13} ./selinux/tomcat8.fc

%build
echo Build Phase
export JAVA_HOME=%{_jvmdir}/java-1.7.0

pushd %{packdname}
    touch HACK
    %{__ln_s} $(build-classpath ecj-eap6/ecj) ecj-%{ecjrev}-eap6.jar
    # We don't care about the tarballs
    # Who needs a build.properties file anyway
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dcommons-daemon.jsvc.tar.gz="HACK" \
        -Djasper-jdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Djdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
        -Dversion.build="%{micro_version}-%{release}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6/commons-collections)" \
        -Dcommons-daemon.jar="%{scldir}%{_javadir}/commons-daemon.jar" \
        -Djava.7.home=${JAVA_HOME} \
            dist-prepare deploy javadoc \
            package-src-zip compile-webapp-examples embed-jars package-src-jar embed-sources
            
    mkdir -p tmp/apache-tomcat-%{version}
    pushd tmp
	    pushd apache-tomcat-%{version}
 	        %{__cp} -r ../../output/build/* .
    	popd
        zip -r -q ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip \
	    apache-tomcat-%{version}/* -x bin/service.bat bin/i64 bin/*.exe bin/*.dll
    popd
    rm -rf tmp

    # extras generation
%if %with ws
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dommons-daemon.jsvc.tar.gz="HACK" \
        -Djasper-jdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Djdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
        -Dversion.build="%{micro_version}-%{release}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6/commons-collections)" \
        -Dcommons-daemon.jar="%{scldir}%{_javadir}/commons-daemon.jar" \
        -Djava.7.home=${JAVA_HOME} \ 
		   extras
%else
    %{ant} -Dbase.path="." \
        -Dbuild.compiler="modern" \
        -Dcommons-daemon.jsvc.tar.gz="HACK" \
        -Djasper-jdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Djdt.jar="ecj-%{ecjrev}-eap6.jar" \
        -Dtomcat-native.tar.gz="" \
        -Dversion="%{version}" \
        -Dversion.build="%{micro_version}-%{version}" \
        -Dcommons-collections.jar="$(build-classpath commons-collections-eap6/commons-colletions)" \
        -Dcommons-daemon.jar="%{scldir}%{_javadir}/commons-daemon.jar" \
        -Dcommons-logging-src.tar.gz="%{SOURCE14}"  \
        -Dservletapi.jar="`pwd`/output/build/lib/servlet-api.jar" \
        -Davalon-framework.jar="$(build-classpath avalon-framework)" \
        -Dlog4j.jar="$(build-classpath log4j-eap6/log4j)" \
	    -Dlog4j12.jar="$(build-classpath log4j-eap6/log4j)" \
        -Dlogkit.jar="$(build-classpath avalon-logkit)" \
        -Djava.7.home=${JAVA_HOME} \
            extras-commons-logging
%endif

    %{__rm} output/build/lib/ecj-%{ecjrev}-eap6.jar
    %{__rm} -r output/build/webapps/examples
    %{__rm} -r output/build/webapps/docs/appdev/sample/*
    #JBPAPP-3659
    #JBPAPP-9557
    %{__rm} -r output/build/webapps/docs/tribes

	# ZIPS
    # make modification in the zip
%if %with zips
    echo Zips

    %{__mkdir_p} tmp
    pushd tmp
    # add jsvc.tar.gz to src.zip
    unzip -q ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip

# rename commons-daemon-eap6 to commons-daemon. it causes problems for downstream
# builds
    cp %{scldir}%{_javadir}/commons-daemon.jar apache-tomcat-%{version}-src/commons-daemon.jar
# COLLECTIONS
    cp $(build-classpath commons-collections-eap6/commons-collections) apache-tomcat-%{version}-src/commons-collections-eap6.jar
#cp $(build-classpath commons-logging/commons-logging-api) apache-tomcat-%{version}-src/commons-logging-api-eap6.jar
#cp $(build-classpath commons-logging/commons-logging-adapters) apache-tomcat-%{version}-src/commons-logging-adapters-eap6.jar
    rm ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip
#JBPAPP-3654 Last chance to get rid of any junk
    find apache-tomcat-%{version}-src -name "*.orig" | xargs -t %{__rm} -f
    zip -q -r ../output/release/v%{version}/src/apache-tomcat-%{version}-src.zip \
       apache-tomcat-%{version}-src
    # maven-devel zip
#    mkdir -p apache-tomcat-%{version}/res/maven
#    %{__cp} ../res/maven/*.pom apache-tomcat-%{version}/res/maven/
#    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}-maven-devel.zip apache-tomcat-%{version}/res/maven/*.pom
#    rm -fr *

    # binary Zip
    unzip -q ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip

    # create zip for QE to run examples
    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}-examples.zip \
         apache-tomcat-%{version}/webapps/examples/servlets/* apache-tomcat-%{version}/webapps/examples/jsp/* \
         apache-tomcat-%{version}/webapps/examples/websocket/* apache-tomcat-%{version}/webapps/examples/WEB-INF \
         apache-tomcat-%{version}/webapps/docs/appdev/sample/*

    # create zip for embed JAR distribution
    cp -r ../output/embed apache-tomcat-%{version}/
    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}-embed.zip \
         apache-tomcat-%{version}/embed/tomcat-embed*.jar
    %{__rm} -r apache-tomcat-%{version}/embed

    # EWS does not ship with tribes
    %{__rm} -r apache-tomcat-%{version}/webapps/docs/tribes
    # Removed viz CVE-2007-1355
    %{__rm} -r apache-tomcat-%{version}/webapps/examples
    %{__rm} -r apache-tomcat-%{version}/webapps/docs/appdev/sample/*
    %{__rm} apache-tomcat-%{version}/lib/ecj-%{ecjrev}-eap6.jar

    cp -pr %{SOURCE15}  apache-tomcat-%{version}/webapps/docs/appdev/sample/index.html
    chmod 755 apache-tomcat-%{version}/bin/*sh
    sed -i -e 's/\"$_RUNJAVA\"/$_RUNJAVA/g' apache-tomcat-%{version}/bin/catalina.sh \
       apache-tomcat-%{version}/bin/tool-wrapper.sh

    # On RHEL-6 the signed JARs are on a different place
#    export JPP_SIGNED=2

	# Replace stock libs with ews libs. Make the rpms and zips symetrical
    echo Zips:Replace stock libs with ews libs
    %{__mkdir_p} apache-tomcat-%{version}/extras
    (cd apache-tomcat-%{version}/extras; %{__ln_s} `build-classpath log4j-eap6/log4j` log4j-eap6.jar;
        %{__cp} %{SOURCE9} log4j.properties ;)
    %{__cp} -pr ../output/extras/tomcat-juli*.jar apache-tomcat-%{version}/extras/
    # Copy the EWS2 libs
    %{__cp} -p %{scldir}%{_javadir}/commons-daemon.jar apache-tomcat-%{version}/bin/commons-daemon.jar
# COLLECTIONS
    %{__cp} -p $(build-classpath commons-collections-eap6/commons-collections) apache-tomcat-%{version}/lib/commons-collections-eap6.jar
#%{__cp} -p $(build-classpath commons-logging/commons-logging-adapters-eap6) apache-tomcat-%{version}/lib/commons-logging-adapters-eap6.jar
#   %{__cp} -p $(build-classpath commons-logging/commons-logging-api-eap6) apache-tomcat-%{version}/lib/commons-logging-api-eap6.jar
    ls apache-tomcat-%{version}/lib/
	# Replace the existing jdt jar with ecj as done for the rpms
    %{__ln_s} $(build-classpath ecj-eap6/ecj) apache-tomcat-%{version}/lib/ecj-%{ecjrev}-eap6.jar
    %{__rm} ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip

#JBPAPP-3654 Last chance to get rid of any junk
    find apache-tomcat-%{version} -name "*.orig" | xargs -t %{__rm} -f
    zip -q -r ../output/release/v%{version}/bin/apache-tomcat-%{version}.zip apache-tomcat-%{version}/
    %{__rm} -fr apache-tomcat-%{version}/extras
    popd
    %{__rm} -fr tmp

	echo End Zips
%endif

pushd ../selinux
  make -f %{_datadir}/selinux/devel/Makefile
  # we don't want to include tmp in the doc distribution
  %{__rm} -rf tmp
popd

%install
echo Install Phase
%{__rm} -rf $RPM_BUILD_ROOT
# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{bindir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/Catalina/localhost
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}/extras
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{logdir}
/bin/touch ${RPM_BUILD_ROOT}%{logdir}/catalina.out
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{tempdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{workdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sbindir}

%if 0%{?rhel} >= 7
    %{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{_localstatedir}/lib/tomcats
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_unitdir}
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_libexecdir}/%{name}
    %{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/conf.d
    /bin/echo "Place your custom *.conf files here. Shell expansion is supported." > ${RPM_BUILD_ROOT}%{confdir}/conf.d/README
%else
    %{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_initrddir}
%endif

# move things into place
echo Install:Copy things into place

pushd %{packdname}/output/build
    %{__cp} -a bin/*.{jar,xml} ${RPM_BUILD_ROOT}%{bindir}
    %{__cp} -a conf/*.{policy,properties,xml,xsd} ${RPM_BUILD_ROOT}%{confdir}
    %{__cp} -a lib/*.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a ../extras/*.jar ${RPM_BUILD_ROOT}%{libdir}/extras
    %{__cp} -a webapps/* ${RPM_BUILD_ROOT}%{appdir}

    cp -p %{SOURCE15} $RPM_BUILD_ROOT%{appdir}/docs/appdev/sample/index.html
    # XXX: install maven central names for jars
    
%if 0%{?rhel} == 6
    %{__ln_s} annotations-api.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-annotations-api.jar
    %{__ln_s} catalina.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-catalina.jar
    %{__ln_s} catalina-ant.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-catalina-ant.jar
    %{__ln_s} jasper.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-jasper.jar
    %{__ln_s} jasper-el.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-jasper-el.jar
    %{__ln_s} el-api.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-el-api.jar
    %{__ln_s} jsp-api.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-jsp-api.jar
    %{__ln_s} servlet-api.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-servlet-api.jar
    %{__ln_s} websocket-api.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-websocket-api.jar
    %{__ln_s} tomcat-websocket.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-tomcat-websocket.jar
    %{__ln_s} tomcat-jni.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-tomcat-jni.jar
    %{__ln_s} tomcat-util-scan.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-tomcat-util-scan.jar
    %{__ln_s} tomcat-dbcp.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-tomcat-dbcp.jar
    %{__ln_s} catalina-storeconfig.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-catalina-storeconfig.jar
%endif

# Add embed JARs into libdir
pushd ../embed
    %{__cp} -a tomcat-embed-core.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a tomcat-embed-jasper.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a tomcat-embed-logging-juli.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a tomcat-embed-websocket.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a tomcat-embed-el.jar ${RPM_BUILD_ROOT}%{libdir}
popd

popd
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2
%if %with ws
# ws
%{__cp} -p %{packdname}/output/extras/catalina-ws.jar ${RPM_BUILD_ROOT}%{libdir}/catalina-ws.jar
%{__ln_s} $(build-classpath axis/jaxrpc) ${RPM_BUILD_ROOT}%{libdir}/jaxrpc.jar
%{__ln_s} $(build-classpath wsdl4j/wsdl4j16) ${RPM_BUILD_ROOT}%{libdir}/wsdl4j.jar
%endif
# juli

# Copy log4j.jar because it is in base Linux
#%{__cp} -p $(build-classpath log4j) ${RPM_BUILD_ROOT}%{libdir}/log4j.jar
%{__cp} -p %{SOURCE9} ${RPM_BUILD_ROOT}%{confdir}/log4j.properties
(cd ${RPM_BUILD_ROOT}%{libdir} && %{__ln_s} %{confdir}/log4j.properties log4j.properties)

# javadoc
pushd %{packdname}/output/dist/webapps
    %{__cp} -a docs/api/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}
popd
#JBPAPP-3659
%{__rm} -rf ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}-%{version}/org/apache/catalina/tribes
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE1} \
    > ${RPM_BUILD_ROOT}%{confdir}/%{name}.conf
%if 0%{?rhel} <= 6
    # JWS-741, remove after creating el specific conf files
    %{__sed} -i 's@ For shell expansion support@@g' ${RPM_BUILD_ROOT}%{confdir}/%{name}.conf
    %{__sed} -i 's@# place your custom files as /etc/tomcat8/conf.d/\*.conf@#@g' ${RPM_BUILD_ROOT}%{confdir}/%{name}.conf
%endif
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE3} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0755 %{SOURCE4} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{name}
%{__sed} -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g" %{SOURCE5} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE6} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-digest
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE7} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-tool-wrapper

%if 0%{?rhel} >= 7
%{__install} -m 0644 %{SOURCE17} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}.service
%{__install} -m 0644 %{SOURCE18} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{name}/functions
%{__install} -m 0755 %{SOURCE19} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{name}/preamble
%{__install} -m 0755 %{SOURCE20} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{name}/server
%{__install} -m 0644 %{SOURCE21} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}@.service
%{__install} -m 0644 %{SOURCE22} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}-jsvc.service
%else
%{__install} -m 0755 %{SOURCE2} \
    ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 0755 %{SOURCE23} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{name}-jsvc
%{__ln_s} %{name} ${RPM_BUILD_ROOT}%{_sbindir}/d%{name}
%endif

pushd ${RPM_BUILD_ROOT}%{libdir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__ln_s} ${j}.jar ${j}-%{version}.jar 
    done
    pushd extras
        for i in *.jar; do
            j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
            %{__ln_s} ${j}.jar ${j}-%{version}.jar 
        done
    popd

# COLLECTIONS
    %{__ln_s} $(build-classpath commons-collections-eap6/commons-collections) commons-collections-eap6.jar

# copy log4j.jar over as it is in base
#    %{__ln_s} $(build-classpath commons-logging/commons-logging-api-eap6) commons-logging-api-eap6.jar
#    %{__ln_s} $(build-classpath commons-logging-eap6/commons-logging-api) commons-logging-api-eap6.jar
#    %{__ln_s} $(build-classapath commons-logging-eap6/commons-logging-adapters) commons-logging-adapters-eap6.jar
    %{__ln_s} $(build-classpath log4j-eap6/log4j) log4j-eap6.jar
# ECJ
    %{__ln_s} $(build-classpath ecj-eap6/ecj) ecj-%{ecjrev}-eap6.jar

popd


pushd ${RPM_BUILD_ROOT}%{_javadir}
    # symlink to maven components
    echo "Link maven components"
#tomcat-jsp-api
    %{__ln_s} %{name}/jsp-api-%{version}.jar \
        %{name}-jsp-%{jspspec}-api-%{version}.jar
# tomcat-servlet-api
    %{__ln_s} %{name}/servlet-api-%{version}.jar \
        %{name}-servlet-%{servletspec}-api-%{version}.jar
# tomcat-el-api
    %{__ln_s} %{name}/el-api-%{version}.jar \
        %{name}-el-%{elspec}-api-%{version}.jar

# extra links to satisfy what's defined for rpms
    %{__ln_s} %{name}-jsp-%{jspspec}-api-%{version}.jar %{name}-jsp-%{jspspec}-api.jar
    %{__ln_s} %{name}-servlet-%{servletspec}-api-%{version}.jar %{name}-servlet-%{servletspec}-api.jar
    %{__ln_s} %{name}-el-%{elspec}-api-%{version}.jar %{name}-el-%{elspec}-api.jar

%if 0%{?rhel} == 6
# tomcat-catalina
    %{__ln_s} %{name}/catalina-%{version}.jar \
        %{name}-catalina-%{version}.jar
# tomcat-coyote
    %{__ln_s} %{name}/tomcat-coyote-%{version}.jar \
        %{name}-tomcat-coyote-%{version}.jar
# tomcat-jasper-el
    %{__ln_s} %{name}/jasper-el-%{version}.jar \
        %{name}-jasper-el-%{version}.jar
# tomcat-jasper
    %{__ln_s} %{name}/jasper-%{version}.jar \
        %{name}-jasper-%{version}.jar
# tomcat-juli
    %{__ln_s} %{bindir}/tomcat-juli-%{version}.jar \
        %{name}-tomcat-juli-%{version}.jar
# tomcat-annotations-api
    %{__ln_s} %{name}/annotations-api-%{version}.jar \
        %{name}-annotations-api-%{version}.jar
# tomcat-cataina-ant
    %{__ln_s} %{name}/catalina-ant-%{version}.jar \
        %{name}-catalina-ant-%{version}.jar
# tomcat-jdbc
    %{__ln_s} %{name}/tomcat-jdbc-%{version}.jar \
        %{name}-tomcat-jdbc-%{version}.jar
# tomcat-api
    %{__ln_s} %{name}/tomcat-api-%{version}.jar \
        %{name}-tomcat-api-%{version}.jar
# tomcat-i18n-fr
    %{__ln_s} %{name}/tomcat-i18n-fr-%{version}.jar \
        %{name}-tomcat-i18n-fr-%{version}.jar
# tomcat-i18n-es
    %{__ln_s} %{name}/tomcat-i18n-es-%{version}.jar \
        %{name}-tomcat-i18n-es-%{version}.jar
# tomcat-i18n-ja
    %{__ln_s} %{name}/tomcat-i18n-ja-%{version}.jar \
        %{name}-tomcat-i18n-ja-%{version}.jar
# tomcat-util
    %{__ln_s} %{name}/tomcat-util-%{version}.jar \
        %{name}-tomcat-util-%{version}.jar
# websocket-api
    %{__ln_s} %{name}/websocket-api-%{version}.jar \
        %{name}-websocket-api-%{version}.jar
# tomcat-websocket
    %{__ln_s} %{name}/tomcat-websocket-%{version}.jar \
        %{name}-tomcat-websocket-%{version}.jar
# tomcat-util-scan
    %{__ln_s} %{name}/tomcat-util-scan-%{version}.jar \
        %{name}-tomcat-util-scan-%{version}.jar
# storeconfig
    %{__ln_s} %{name}/catalina-storeconfig-%{version}.jar \
        %{name}-catalina-storeconfig-%{version}.jar
# tomcat-jni
    %{__ln_s} %{name}/tomcat-jni-%{version}.jar \
        %{name}-tomcat-jni-%{version}.jar
# tomcat-dbcp
    %{__ln_s} %{name}/tomcat-dbcp-%{version}.jar \
        %{name}-tomcat-dbcp-%{version}.jar
%endif

# links set up by  update-alternatives
    /bin/touch el_%{elspecalt}_api.jar
    /bin/touch el-api.jar
    /bin/touch jsp-api.jar
    /bin/touch servlet-api.jar
popd

pushd ${RPM_BUILD_ROOT}%{bindir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done
popd
# symlink to the FHS locations where we've installed things
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{confdir} conf
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
    %{__ln_s} %{tempdir} temp
    %{__ln_s} %{workdir} work
popd

# construct the maven dependency map
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if 0%{?rhel} == 6
# coyote
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-coyote.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-coyote.pom
%add_to_maven_depmap org.apache.tomcat tomcat-coyote %{version} JPP/%{name} tomcat-coyote

%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-coyote
# catalina
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina.pom \
       %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-catalina.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina %{version} JPP/%{name} tomcat-catalina
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-catalina
# el-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-el-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-el-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-el-api %{version} JPP/%{name} tomczt-el-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-el-api

# jasper-el
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper-el.pom \
    %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jasper-el.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jasper-el %{version} JPP/%{name} tomcat-jasper-el
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-jasper-el

# jasper
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jasper.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jasper %{version} JPP/%{name} tomcat-jasper
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-jasper

# jsp-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jsp-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jsp-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jsp-api %{version} JPP/%{name} tomcat-jsp-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-jsp-api

# servlet-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-servlet-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-servlet-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-servlet-api %{version} JPP/%{name} tomcat-servlet-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-servlet-api

# juli
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-juli.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-juli.pom
%add_to_maven_depmap org.apache.tomcat tomcat-juli %{version} JPP/%{name} tomcat-juli
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-juli

# annotations api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-annotations-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-annotations-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-annotations-api %{version} JPP/%{name} tomcat-annotations-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-annotations-api

# catalina-ant
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina-ant.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-catalina-ant.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina-ant %{version} JPP/%{name} tomcat-catalina-ant
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-catalina-ant

# tomcat-i18n-fr
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-fr.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-fr.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-fr  %{version} JPP/%{name} tomcat-i18n-fr
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-i18n-fr

# tomcat-i18n-es
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-es.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-es.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-es  %{version} JPP/%{name} tomcat-i18n-es
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-i18n-es

# tomcat-i18n-es
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-ja.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-ja.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-ja  %{version} JPP/%{name} tomcat-i18n-ja
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-i18n-ja

# tomcat-jdbc
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jdbc.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jdbc.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jdbc  %{version} JPP/%{name} tomcat-jdbc
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-jdbc

# tomcat-util
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-util.pom
%add_to_maven_depmap org.apache.tomcat tomcat-util %{version} JPP/%{name} tomcat-util
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-util

# tomcat-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-api %{version} JPP/%{name} tomcat-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-api

# tomcat-extras-juli-adapters
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli-adapters.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli-adapters.pom
%add_to_maven_depmap org.apache.tomcat tomcat-extras-juli-adpaters %{version}JPP/%{name} tomcat-extras-juli-adapters
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli-adapters

# tomcat-extras-juli
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli.pom
%add_to_maven_depmap org.apache.tomcat tomcat-extras-juli%{version}JPP/%{name} tomcat-extras-juli
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli

# tomcat-websocket-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-websocket-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-websocket-api%{version}JPP/%{name} tomcat-websocket-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-websocket-api

# tomcat-tomcat-websocket.jar
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-websocket.pom
%add_to_maven_depmap org.apache.tomcat tomcat-websocket%{version}JPP/%{name} tomcat-websocket
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-websocket

# tomcat-tomcat-util-scan.jar
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util-scan.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-util-scan.pom
%add_to_maven_depmap org.apache.tomcat tomcat-util-scan%{version}JPP/%{name} tomcat-util-scan
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-util-scan

%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jni.pom \
                %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jni.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jni%{version}JPP/%{name} tomcat-jni
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-jni

%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-dbcp.pom \
                %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-dbcp.pom
%add_to_maven_depmap org.apache.tomcat tomcat-dbcp%{version}JPP/%{name} tomcat-dbcp
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-dbcp

%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-storeconfig.pom \
                %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-catalina-storeconfig.pom
%add_to_maven_depmap org.apache.tomcat tomcat-storeconfig%{version}JPP/%{name} tomcat-catalina-storeconfig
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-catalina-storeconfig

# tomcat embedded jars
for ej in tomcat-embed-core tomcat-embed-jasper tomcat-embed-logging-juli \
    tomcat-embed-websocket tomcat-embed-el; do
    %{__cp} -p apache-tomcat-%{version}-src/res/maven/${ej}.pom \
                    %{buildroot}%{_mavenpomdir}/JPP.%{name}-${ej}.pom
    %add_to_maven_depmap org.apache.tomcat ${ej}-%{version}JPP/%{name} ${ej}
    %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
            %{buildroot}%{_mavendepmapfragdir}/%{name}-${ej}
done
%else
# coyote
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-coyote.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-coyote.pom
%add_maven_depmap JPP.%{name}-tomcat-coyote.pom %{name}/tomcat-coyote.jar

# catalina
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina.pom \
       %{buildroot}%{_mavenpomdir}/JPP.%{name}-catalina.pom
%add_maven_depmap JPP.%{name}-catalina.pom %{name}/catalina.jar
# el-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-el-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-el-api.pom
%add_maven_depmap JPP.%{name}-el-api.pom %{name}/el-api.jar

# jasper-el
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper-el.pom \
    %{buildroot}%{_mavenpomdir}/JPP.%{name}-jasper-el.pom
%add_maven_depmap JPP.%{name}-jasper-el.pom %{name}/jasper-el.jar 

# jasper
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-jasper.pom
%add_maven_depmap JPP.%{name}-jasper.pom %{name}/jasper.jar

# jsp-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jsp-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-jsp-api.pom
%add_maven_depmap JPP.%{name}-jsp-api.pom %{name}/jsp-api.jar

# servlet-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-servlet-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-servlet-api.pom
%add_maven_depmap JPP.%{name}-servlet-api.pom %{name}/servlet-api.jar

# juli
#%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-juli.pom \
#        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-juli.pom
#%add_to_maven_depmap org.apache.tomcat tomcat-juli %{version} JPP/%{name} tomcat-juli
#%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
#        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-juli

# annotations api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-annotations-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-annotations-api.pom
%add_maven_depmap JPP.%{name}-annotations-api.pom %{name}/annotations-api.jar

# catalina-ant
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina-ant.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-catalina-ant.pom
%add_maven_depmap JPP.%{name}-catalina-ant.pom %{name}/catalina-ant.jar

# tomcat-i18n-fr
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-fr.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-fr.pom
%add_maven_depmap JPP.%{name}-tomcat-i18n-fr.pom %{name}/tomcat-i18n-fr.jar

# tomcat-i18n-es
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-es.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-es.pom
%add_maven_depmap JPP.%{name}-tomcat-i18n-es.pom %{name}/tomcat-i18n-es.jar

# tomcat-i18n-es
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-ja.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-ja.pom
%add_maven_depmap JPP.%{name}-tomcat-i18n-ja.pom %{name}/tomcat-i18n-ja.jar

# tomcat-jdbc
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jdbc.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jdbc.pom
%add_maven_depmap JPP.%{name}-tomcat-jdbc.pom %{name}/tomcat-jdbc.jar

# tomcat-util
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-util.pom
%add_maven_depmap JPP.%{name}-tomcat-util.pom %{name}/tomcat-util.jar

# tomcat-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-api.pom
%add_maven_depmap JPP.%{name}-tomcat-api.pom %{name}/tomcat-api.jar

# tomcat-extras-juli-adapters
#%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli-adapters.pom \
#        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli-adapters.pom
#%add_to_maven_depmap org.apache.tomcat tomcat-extras-juli-adpaters %{version}JPP/%{name} tomcat-extras-juli-adapters
#%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
#        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli-adapters

# tomcat-extras-juli
#%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli.pom \
#        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli.pom
#%add_to_maven_depmap org.apache.tomcat tomcat-extras-juli%{version}JPP/%{name} tomcat-extras-juli
#%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} \
#        %{buildroot}%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli

# tomcat-websocket-api
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket-api.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-websocket-api.pom
%add_maven_depmap JPP.%{name}-websocket-api.pom %{name}/websocket-api.jar

# tomcat-tomcat-websocket.jar
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-websocket.pom
%add_maven_depmap JPP.%{name}-tomcat-websocket.pom %{name}/tomcat-websocket.jar

# tomcat-tomcat-util-scan.jar
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util-scan.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-util-scan.pom
%add_maven_depmap JPP.%{name}-tomcat-util-scan.pom %{name}/tomcat-util-scan.jar

#tomcat-jni
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jni.pom \
                %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-jni.pom
%add_maven_depmap JPP.%{name}-tomcat-jni.pom %{name}/tomcat-jni.jar

#tomcat-dbcp
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-dbcp.pom \
                %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-dbcp.pom
%add_maven_depmap JPP.%{name}-tomcat-dbcp.pom %{name}/tomcat-dbcp.jar

#tomcat-storeconfig
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-storeconfig.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-catalina-storeconfig.pom
%add_maven_depmap JPP.%{name}-catalina-storeconfig.pom %{name}/catalina-storeconfig.jar

# tomcat-embed-core
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-core.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-embed-core.pom
%add_maven_depmap JPP.%{name}-tomcat-embed-core.pom %{name}/tomcat-embed-core.jar

# tomcat-embed-jasper
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-jasper.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-embed-jasper.pom
%add_maven_depmap JPP.%{name}-tomcat-embed-jasper.pom %{name}/tomcat-embed-jasper.jar

# tomcat-embed-logging-juli
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-logging-juli.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-embed-logging-juli.pom
%add_maven_depmap JPP.%{name}-tomcat-embed-logging-juli.pom %{name}/tomcat-embed-logging-juli.jar

# tomcat-embed-websocket
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-websocket.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-embed-websocket.pom
%add_maven_depmap JPP.%{name}-tomcat-embed-websocket.pom %{name}/tomcat-embed-websocket.jar

# tomcat-embed-el
%{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-el.pom \
        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-embed-el.pom
%add_maven_depmap JPP.%{name}-tomcat-embed-el.pom %{name}/tomcat-embed-el.jar
%endif


%if %with zips
echo Zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
# Copy over source zip for the src-zip subpackage
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/src/apache-tomcat-%{version}-src.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat8-%{version}-src.zip
# Copy over zip for the zip subpackage
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}-examples.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat8-%{version}-examples.zip
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}-embed.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat8-%{version}-embed.zip
%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat8-%{version}.zip
#%{__install} -p -m 0644 %{packdname}/output/release/v%{version}/bin/apache-tomcat-%{version}-maven-devel.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/tomcat8-%{version}-maven-devel.zip
echo End Zips
%endif

%if %with repolib
    echo RepoLib
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 0644 %{SOURCE10} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
    tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
    sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml

	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE7} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE9} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE12} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE13} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE14} $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 0644 %{SOURCE15} $RPM_BUILD_ROOT%{repodirsrc}

    %if 0%{?rhel} >= 7
        install -p -m 0644 %{SOURCE17} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE18} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE19} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE20} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE21} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE22} $RPM_BUILD_ROOT%{repodirsrc}
    %else
        install -p -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
        install -p -m 0644 %{SOURCE23} $RPM_BUILD_ROOT%{repodirsrc}
    %endif

    %if 0%{?rhel} == 7
        %define mvntomcatroot %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/org/apache/tomcat
        %{__mkdir_p} %{mvntomcatroot}

        %{__mkdir_p} %{mvntomcatroot}/tomcat-catalina/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/catalina.jar %{mvntomcatroot}/tomcat-catalina/%{artifactversion}/tomcat-catalina-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/catalina-src.jar %{mvntomcatroot}/tomcat-catalina/%{artifactversion}/tomcat-catalina-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina.pom %{mvntomcatroot}/tomcat-catalina/%{artifactversion}/tomcat-catalina-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-coyote/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-coyote.jar %{mvntomcatroot}/tomcat-coyote/%{artifactversion}/tomcat-coyote-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-coyote-src.jar %{mvntomcatroot}/tomcat-coyote/%{artifactversion}/tomcat-coyote-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-coyote.pom %{mvntomcatroot}/tomcat-coyote/%{artifactversion}/tomcat-coyote-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-el-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/el-api.jar %{mvntomcatroot}/tomcat-el-api/%{artifactversion}/tomcat-el-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/el-api-src.jar %{mvntomcatroot}/tomcat-el-api/%{artifactversion}/tomcat-el-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-el-api.pom %{mvntomcatroot}/tomcat-el-api/%{artifactversion}/tomcat-el-api-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-jasper-el/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/jasper-el.jar %{mvntomcatroot}/tomcat-jasper-el/%{artifactversion}/tomcat-jasper-el-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/jasper-el-src.jar %{mvntomcatroot}/tomcat-jasper-el/%{artifactversion}/tomcat-jasper-el-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper-el.pom %{mvntomcatroot}/tomcat-jasper-el/%{artifactversion}/tomcat-jasper-el-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-jasper/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/jasper.jar %{mvntomcatroot}/tomcat-jasper/%{artifactversion}/tomcat-jasper-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/jasper-src.jar %{mvntomcatroot}/tomcat-jasper/%{artifactversion}/tomcat-jasper-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jasper.pom %{mvntomcatroot}/tomcat-jasper/%{artifactversion}/tomcat-jasper-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-jsp-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/jsp-api.jar %{mvntomcatroot}/tomcat-jsp-api/%{artifactversion}/tomcat-jsp-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/jsp-api-src.jar %{mvntomcatroot}/tomcat-jsp-api/%{artifactversion}/tomcat-jsp-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jsp-api.pom %{mvntomcatroot}/tomcat-jsp-api/%{artifactversion}/tomcat-jsp-api-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-servlet-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/servlet-api.jar %{mvntomcatroot}/tomcat-servlet-api/%{artifactversion}/tomcat-servlet-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/servlet-api-src.jar %{mvntomcatroot}/tomcat-servlet-api/%{artifactversion}/tomcat-servlet-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-servlet-api.pom %{mvntomcatroot}/tomcat-servlet-api/%{artifactversion}/tomcat-servlet-api-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-juli/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/bin/tomcat-juli.jar %{mvntomcatroot}/tomcat-juli/%{artifactversion}/tomcat-juli-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-juli-src.jar %{mvntomcatroot}/tomcat-juli/%{artifactversion}/tomcat-juli-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-juli.pom %{mvntomcatroot}/tomcat-juli/%{artifactversion}/tomcat-juli-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-annotations-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/annotations-api.jar %{mvntomcatroot}/tomcat-annotations-api/%{artifactversion}/tomcat-annotations-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/annotations-api-src.jar %{mvntomcatroot}/tomcat-annotations-api/%{artifactversion}/tomcat-annotations-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-annotations-api.pom %{mvntomcatroot}/tomcat-annotations-api/%{artifactversion}/tomcat-annotations-api-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-catalina-ant/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/catalina-ant.jar %{mvntomcatroot}/tomcat-catalina-ant/%{artifactversion}/tomcat-catalina-ant-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/catalina-ant-src.jar %{mvntomcatroot}/tomcat-catalina-ant/%{artifactversion}/tomcat-catalina-ant-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-catalina-ant.pom %{mvntomcatroot}/tomcat-catalina-ant/%{artifactversion}/tomcat-catalina-ant-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-jdbc/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-jdbc.jar %{mvntomcatroot}/tomcat-jdbc/%{artifactversion}/tomcat-jdbc-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-jdbc-src.jar %{mvntomcatroot}/tomcat-jdbc/%{artifactversion}/tomcat-jdbc-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jdbc.pom %{mvntomcatroot}/tomcat-jdbc/%{artifactversion}/tomcat-jdbc-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-api.jar %{mvntomcatroot}/tomcat-api/%{artifactversion}/tomcat-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-api-src.jar %{mvntomcatroot}/tomcat-api/%{artifactversion}/tomcat-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-api.pom %{mvntomcatroot}/tomcat-api/%{artifactversion}/tomcat-api-%{artifactversion}.pom

        # The locale JARs don't produce sources JARs because they're just collections of properties files
        %{__mkdir_p} %{mvntomcatroot}/tomcat-i18n-fr/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-i18n-fr.jar %{mvntomcatroot}/tomcat-i18n-fr/%{artifactversion}/tomcat-i18n-fr-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-fr.pom %{mvntomcatroot}/tomcat-i18n-fr/%{artifactversion}/tomcat-i18n-fr-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-i18n-es/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-i18n-es.jar %{mvntomcatroot}/tomcat-i18n-es/%{artifactversion}/tomcat-i18n-es-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-es.pom %{mvntomcatroot}/tomcat-i18n-es/%{artifactversion}/tomcat-i18n-es-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-i18n-ja/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-i18n-ja.jar %{mvntomcatroot}/tomcat-i18n-ja/%{artifactversion}/tomcat-i18n-ja-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-i18n-ja.pom %{mvntomcatroot}/tomcat-i18n-ja/%{artifactversion}/tomcat-i18n-ja-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-util/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-util.jar %{mvntomcatroot}/tomcat-util/%{artifactversion}/tomcat-util-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-util-src.jar %{mvntomcatroot}/tomcat-util/%{artifactversion}/tomcat-util-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util.pom %{mvntomcatroot}/tomcat-util/%{artifactversion}/tomcat-util-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-websocket-api/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/websocket-api.jar %{mvntomcatroot}/tomcat-websocket-api/%{artifactversion}/tomcat-websocket-api-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/websocket-api-src.jar %{mvntomcatroot}/tomcat-websocket-api/%{artifactversion}/tomcat-websocket-api-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket-api.pom %{mvntomcatroot}/tomcat-websocket-api/%{artifactversion}/tomcat-websocket-api-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-websocket/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-websocket.jar %{mvntomcatroot}/tomcat-websocket/%{artifactversion}/tomcat-websocket-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-websocket-src.jar %{mvntomcatroot}/tomcat-websocket/%{artifactversion}/tomcat-websocket-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-websocket.pom %{mvntomcatroot}/tomcat-websocket/%{artifactversion}/tomcat-websocket-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/extras/tomcat-extras-juli-adapters/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/extras/tomcat-juli-adapters.jar %{mvntomcatroot}/extras/tomcat-extras-juli-adapters/%{artifactversion}/tomcat-extras-juli-adapters-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/extras-src-jars/tomcat-juli-adapters-src.jar %{mvntomcatroot}/extras/tomcat-extras-juli-adapters/%{artifactversion}/tomcat-extras-juli-adapters-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli-adapters.pom %{mvntomcatroot}/extras/tomcat-extras-juli-adapters/%{artifactversion}/tomcat-extras-juli-adapters-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/extras/tomcat-extras-juli/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/extras/tomcat-juli.jar %{mvntomcatroot}/extras/tomcat-extras-juli/%{artifactversion}/tomcat-extras-juli-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/extras-src-jars/tomcat-juli-src.jar %{mvntomcatroot}/extras/tomcat-extras-juli/%{artifactversion}/tomcat-extras-juli-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-extras-juli.pom %{mvntomcatroot}/extras/tomcat-extras-juli/%{artifactversion}/tomcat-extras-juli-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-util-scan/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-util-scan.jar %{mvntomcatroot}/tomcat-util-scan/%{artifactversion}/tomcat-util-scan-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-util-scan-src.jar %{mvntomcatroot}/tomcat-util-scan/%{artifactversion}/tomcat-util-scan-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-util-scan.pom %{mvntomcatroot}/tomcat-util-scan/%{artifactversion}/tomcat-util-scan-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-jni/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-jni.jar %{mvntomcatroot}/tomcat-jni/%{artifactversion}/tomcat-jni-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-jni-src.jar %{mvntomcatroot}/tomcat-jni/%{artifactversion}/tomcat-jni-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-jni.pom %{mvntomcatroot}/tomcat-jni/%{artifactversion}/tomcat-jni-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/tomcat-dbcp/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/build/lib/tomcat-dbcp.jar %{mvntomcatroot}/tomcat-dbcp/%{artifactversion}/tomcat-dbcp-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/src-jars/tomcat-dbcp-src.jar %{mvntomcatroot}/tomcat-dbcp/%{artifactversion}/tomcat-dbcp-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-dbcp.pom %{mvntomcatroot}/tomcat-dbcp/%{artifactversion}/tomcat-dbcp-%{artifactversion}.pom

        # embed jars for maven
        %{__mkdir_p} %{mvntomcatroot}/embed/tomcat-embed-core/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/embed/tomcat-embed-core.jar %{mvntomcatroot}/embed/tomcat-embed-core/%{artifactversion}/tomcat-embed-core-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/embed-src-jars/tomcat-embed-core-src.jar %{mvntomcatroot}/embed/tomcat-embed-core/%{artifactversion}/tomcat-embed-core-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-core.pom %{mvntomcatroot}/embed/tomcat-embed-core/%{artifactversion}/tomcat-embed-core-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/embed/tomcat-embed-jasper/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/embed/tomcat-embed-jasper.jar %{mvntomcatroot}/embed/tomcat-embed-jasper/%{artifactversion}/tomcat-embed-jasper-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/embed-src-jars/tomcat-embed-jasper-src.jar %{mvntomcatroot}/embed/tomcat-embed-jasper/%{artifactversion}/tomcat-embed-jasper-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-jasper.pom %{mvntomcatroot}/embed/tomcat-embed-jasper/%{artifactversion}/tomcat-embed-jasper-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/embed/tomcat-embed-logging-juli/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/embed/tomcat-embed-logging-juli.jar %{mvntomcatroot}/embed/tomcat-embed-logging-juli/%{artifactversion}/tomcat-embed-logging-juli-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/embed-src-jars/tomcat-embed-logging-juli-src.jar %{mvntomcatroot}/embed/tomcat-embed-logging-juli/%{artifactversion}/tomcat-embed-logging-juli-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-logging-juli.pom %{mvntomcatroot}/embed/tomcat-embed-logging-juli/%{artifactversion}/tomcat-embed-logging-juli-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/embed/tomcat-embed-websocket/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/embed/tomcat-embed-websocket.jar %{mvntomcatroot}/embed/tomcat-embed-websocket/%{artifactversion}/tomcat-embed-websocket-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/embed-src-jars/tomcat-embed-websocket-src.jar %{mvntomcatroot}/embed/tomcat-embed-websocket/%{artifactversion}/tomcat-embed-websocket-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-websocket.pom %{mvntomcatroot}/embed/tomcat-embed-websocket/%{artifactversion}/tomcat-embed-websocket-%{artifactversion}.pom

        %{__mkdir_p} %{mvntomcatroot}/embed/tomcat-embed-el/%{artifactversion}
        %{__cp} -p apache-tomcat-%{version}-src/output/embed/tomcat-embed-el.jar %{mvntomcatroot}/embed/tomcat-embed-el/%{artifactversion}/tomcat-embed-el-%{artifactversion}.jar
        %{__cp} -p apache-tomcat-%{version}-src/output/embed-src-jars/tomcat-embed-el-src.jar %{mvntomcatroot}/embed/tomcat-embed-el/%{artifactversion}/tomcat-embed-el-%{artifactversion}-sources.jar
        %{__cp} -p apache-tomcat-%{version}-src/res/maven/tomcat-embed-el.pom %{mvntomcatroot}/embed/tomcat-embed-el/%{artifactversion}/tomcat-embed-el-%{artifactversion}.pom
    %endif

echo End RepoLib
%endif

install -d $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}
install -p -m 644 selinux/%{name}.pp $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}/%{name}.pp

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add the tomcat user and group
%{_sbindir}/groupadd -g %{tcuid} -r tomcat 2>/dev/null || :
%{_sbindir}/useradd -c "Apache Tomcat" -u %{tcuid} -g tomcat \
    -s /sbin/nologin -r -d %{homedir} tomcat 2>/dev/null || :

%post
# install but don't activate
%if 0%{?rhel} >= 7
%systemd_post %{name}.service
%else
/sbin/chkconfig --add %{name}
%endif

%update_maven_depmap

%post lib
%update_maven_depmap

%postun lib
%update_maven_depmap

%pre javadoc
%{__rm} -rf %{_javadocdir}/%{name}

# el-api
%post el-%{elspec}-api
    %{_sbindir}/update-alternatives --install %{_javadir}/el-api.jar el-api %{_javadir}/%{name}-el-%{elspec}-api.jar 20500
    %{_sbindir}/update-alternatives --install %{_javadir}/el_%{elspecalt}_api.jar el_%{elspecalt}_api %{_javadir}/%{name}-el-%{elspec}-api.jar 20500
%update_maven_depmap

%postun el-%{elspec}-api
%update_maven_depmap

%preun el-%{elspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove el-api %{_javadir}/%{name}-el-%{elspec}-api.jar
    %{_sbindir}/update-alternatives --remove el_%{elspecalt}_api %{_javadir}/%{name}-el-%{elspec}-api.jar
fi

# jsp api
%post jsp-%{jspspec}-api
%{_sbindir}/update-alternatives --install %{_javadir}/jsp-api.jar jsp-api \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20300
%update_maven_depmap

%postun jsp-%{jspspec}-api
%update_maven_depmap

%preun jsp-%{jspspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jsp-api \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
fi

# servlet-api
%post servlet-%{servletspec}-api
# On RHEL-6 the signed JARs are on a different place
#export JPP_SIGNED=2
%{_sbindir}/update-alternatives --install %{_javadir}/servlet-api.jar servlet-api \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 32000
%update_maven_depmap

%postun servlet-%{servletspec}-api
%update_maven_depmap

%preun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove servlet-api \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
fi

%preun
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*

%if 0%{?rhel} >= 7
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*
%systemd_preun %{name}.service
%else
if [ "$1" = "0" ]; then
    %{_initrddir}/%{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
%endif

%postun
%update_maven_depmap

%if 0%{?rhel} >= 7
%systemd_postun_with_restart %{name}.service
%endif

%pre selinux
%if 0%{?rhel} <= 6
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi
if %{_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    [ -f %{_file_context_file_pre} ] || cp -f %{_file_context_file} %{_file_context_file_pre}
fi
%else
%selinux_relabel_pre
%endif

%post selinux
# On update, cleanup previous iterations of the policy which were added at
# the wrong priority. If a 400 prio policy doesn't exist, go on about your
# merry way
if [ $1 -eq 2 ]; then
    /usr/sbin/semodule -X 400 -r %{name} > /dev/null 2>&1 || :
fi

%if 0%{?rhel} <= 6
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi
/usr/sbin/semodule -n -s ${_policytype} -i %{_datadir}/selinux/packages/%{name}/%{name}.pp
if %{_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    %{_sbindir}/load_policy
    if [ -f %{_file_context_file_pre} ]; then
        /sbin/fixfiles -C %{_file_context_file_pre} restore
        /sbin/restorecon %{_initrddir}/%{name} &> /dev/null
        rm -f %{_file_context_file_pre}
    fi
fi

# mxi_port doesn't exist on rhel-6, so we need to allow tomcat to bind to 8005
/usr/sbin/semanage port -a -t http_port_t -p tcp 8005 > /dev/null 2>&1 || :
%else
%selinux_modules_install %{_datadir}/selinux/packages/%{name}/%{name}.pp
%selinux_relabel_post
%endif

%postun selinux
%if 0%{?rhel} >= 7
    %selinux_modules_uninstall %{name}
%endif
if [ $1 -eq 0 ]; then
%if 0%{?rhel} <= 6
    . /etc/selinux/config
    _policytype=
    if [ -z "${_policytype}" ]; then
      _policytype="targeted"
    fi

    /usr/sbin/semodule -n -r %{name} &> /dev/null || :
    if /usr/sbin/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
       /usr/sbin/load_policy
       if [ -f %{_file_context_file_pre} ]; then
         /sbin/fixfiles -C %{_file_context_file_pre} restore
         rm -f %{_file_context_file_pre}
       fi
    fi

    # mxi_port doesn't exist on rhel-6, so we need to cleanup the port we added in %%post
    /usr/sbin/semanage port -d -t http_port_t -p tcp 8005 > /dev/null 2>&1 || :
%else
    %selinux_relabel_post
%endif
fi

%files
%defattr(0640,root,root,0750)
%attr(0644,root,root) %doc %{packdname}/{LICENSE,NOTICE,RELEASE-NOTES,*.txt}
%attr(0755,root,root) %{_bindir}/%{name}-digest
%attr(0755,root,root) %{_bindir}/%{name}-tool-wrapper
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%if 0%{?rhel} <= 6
    %attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
    %attr(0640,tomcat,tomcat) %{logdir}/catalina.out
%endif

%defattr(0640,root,tomcat,0750)
%dir %{basedir}
%attr(0751,root,tomcat) %dir %{homedir}
%dir %{confdir}
%attr(0770,root,tomcat) %dir %{confdir}/Catalina
%attr(0770,root,tomcat) %dir %{confdir}/Catalina/localhost
%if 0%{?rhel} >= 7
    %dir %{confdir}/conf.d
    %{confdir}/conf.d/README
%endif
%config(noreplace) %{confdir}/%{name}.conf
%config(noreplace) %{confdir}/catalina.policy
%config(noreplace) %{confdir}/catalina.properties
%config(noreplace) %{confdir}/logging.properties
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/tomcat-users.xml
%{confdir}/tomcat-users.xsd
%config(noreplace) %{confdir}/web.xml
# Tomcat needs to write to all of these dirs
%attr(0770,tomcat,tomcat) %dir %{cachedir}
%attr(0770,tomcat,tomcat) %dir %{tempdir}
%attr(0770,tomcat,tomcat) %dir %{workdir}
%attr(0770,tomcat,tomcat) %dir %{appdir}
# Slightly more restrictive group access (-w) on the logs
%attr(0750,tomcat,tomcat) %dir %{logdir}

%defattr(0644,root,root,0755)
%{bindir}/bootstrap-%{version}.jar
%{bindir}/bootstrap.jar
%{bindir}/catalina-tasks.xml
%{bindir}/commons-daemon.jar
%{bindir}/commons-daemon-%{version}.jar
%{bindir}/tomcat-juli-%{version}.jar
%{bindir}/tomcat-juli.jar

%defattr(0640,root,root,0750)
%{homedir}/conf
%{homedir}/lib
%{homedir}/logs
%{homedir}/temp
%{homedir}/webapps
%{homedir}/work

%defattr(0755,root,root,0755)
%{_sbindir}/%{name}
%if 0%{?rhel} >= 7
    %{_unitdir}/%{name}.service
    %{_unitdir}/%{name}@.service
    %dir %{_libexecdir}/%{name}
    %dir %{_localstatedir}/lib/tomcats
    %{_libexecdir}/%{name}/functions
    %{_libexecdir}/%{name}/preamble
    %{_libexecdir}/%{name}/server
%else
    %{_sbindir}/d%{name}
    %{_initrddir}/%{name}
%endif

%files webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/ROOT

%files admin-webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/host-manager
%{appdir}/manager
%config(noreplace) %{appdir}/manager/WEB-INF/web.xml
%config(noreplace) %{appdir}/host-manager/WEB-INF/web.xml

%if %with ws
%files ws
%defattr(0644,root,root,0755)
%{libdir}/catalina-ws-%{version}.jar
%{libdir}/catalina-ws.jar
%{libdir}/jaxrpc-%{version}.jar
%{libdir}/jaxrpc.jar
%{libdir}/wsdl4j-%{version}.jar
%{libdir}/wsdl4j.jar
%endif

%files docs-webapp
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/docs

%files maven-devel
%defattr(0644,root,root,0555)

%if 0%{?rhel} == 6
%{_mavenpomdir}/JPP.%{name}-tomcat-juli.pom
%{_mavendepmapfragdir}/%{name}-tomcat-juli
%{_mavenpomdir}/JPP.%{name}-tomcat-el-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-el-api
%{_mavenpomdir}/JPP.%{name}-tomcat-jsp-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-jsp-api
%{_mavenpomdir}/JPP.%{name}-tomcat-servlet-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-servlet-api
%{_mavendepmapfragdir}/%{name}-tomcat-coyote
%{_mavenpomdir}/JPP.%{name}-tomcat-coyote.pom
%{_mavendepmapfragdir}/%{name}-tomcat-catalina
%{_mavenpomdir}/JPP.%{name}-tomcat-catalina.pom
%{_mavendepmapfragdir}/%{name}-tomcat-jasper-el
%{_mavenpomdir}/JPP.%{name}-tomcat-jasper-el.pom
%{_mavendepmapfragdir}/%{name}-tomcat-jasper
%{_mavenpomdir}/JPP.%{name}-tomcat-jasper.pom
%{_mavendepmapfragdir}/%{name}-tomcat-annotations-api
%{_mavenpomdir}/JPP.%{name}-tomcat-annotations-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-catalina-ant
%{_mavenpomdir}/JPP.%{name}-tomcat-catalina-ant.pom
%{_mavendepmapfragdir}/%{name}-tomcat-i18n-fr
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-fr.pom
%{_mavendepmapfragdir}/%{name}-tomcat-i18n-es
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-es.pom
%{_mavendepmapfragdir}/%{name}-tomcat-i18n-ja
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-ja.pom
%{_mavendepmapfragdir}/%{name}-tomcat-util
%{_mavenpomdir}/JPP.%{name}-tomcat-util.pom
%{_mavendepmapfragdir}/%{name}-tomcat-api
%{_mavenpomdir}/JPP.%{name}-tomcat-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-jdbc
%{_mavenpomdir}/JPP.%{name}-tomcat-jdbc.pom
%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli
%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli.pom
%{_mavendepmapfragdir}/%{name}-tomcat-extras-juli-adapters
%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli-adapters.pom
%{_mavendepmapfragdir}/%{name}-tomcat-websocket-api
%{_mavenpomdir}/JPP.%{name}-tomcat-websocket-api.pom
%{_mavendepmapfragdir}/%{name}-tomcat-websocket
%{_mavenpomdir}/JPP.%{name}-tomcat-websocket.pom
%{_mavendepmapfragdir}/%{name}-tomcat-util-scan
%{_mavenpomdir}/JPP.%{name}-tomcat-util-scan.pom
%{_mavendepmapfragdir}/%{name}-tomcat-jni
%{_mavenpomdir}/JPP.%{name}-tomcat-jni.pom
%{_mavendepmapfragdir}/%{name}-tomcat-dbcp
%{_mavenpomdir}/JPP.%{name}-tomcat-dbcp.pom
%{_mavendepmapfragdir}/%{name}-tomcat-catalina-storeconfig
%{_mavenpomdir}/JPP.%{name}-tomcat-catalina-storeconfig.pom
# embed poms
%{_mavendepmapfragdir}/%{name}-tomcat-embed-core
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-core.pom
%{_mavendepmapfragdir}/%{name}-tomcat-embed-jasper
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-jasper.pom
%{_mavendepmapfragdir}/%{name}-tomcat-embed-logging-juli
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-logging-juli.pom
%{_mavendepmapfragdir}/%{name}-tomcat-embed-websocket
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-websocket.pom
%{_mavendepmapfragdir}/%{name}-tomcat-embed-el
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-el.pom
# needed artifacts. some tomcat artifacts won't
# appear here because they are already prefixed
# with 'tomcat-'. JPP maven naming conventions
# requires a 'tomcat-' prefix. the only artifacts that 
# are in the list are the tomcat artifacts
# that are not prefixed with 'tomcat-'.
%{libdir}/tomcat-annotations-api.jar
%{libdir}/tomcat-annotations-api-%{version}.jar
%{libdir}/tomcat-catalina.jar
%{libdir}/tomcat-catalina-%{version}.jar
%{libdir}/tomcat-catalina-ant.jar
%{libdir}/tomcat-catalina-ant-%{version}.jar
%{libdir}/tomcat-websocket-api.jar
%{libdir}/tomcat-websocket-api-%{version}.jar
%{libdir}/tomcat-tomcat-websocket.jar
%{libdir}/tomcat-tomcat-websocket-%{version}.jar
%{libdir}/tomcat-jasper.jar
%{libdir}/tomcat-jasper-%{version}.jar
%{libdir}/tomcat-jasper-el.jar
%{libdir}/tomcat-jasper-el-%{version}.jar
%{libdir}/tomcat-el-api.jar
%{libdir}/tomcat-el-api-%{version}.jar
%{libdir}/tomcat-jsp-api.jar
%{libdir}/tomcat-jsp-api-%{version}.jar
%{libdir}/tomcat-servlet-api.jar
%{libdir}/tomcat-servlet-api-%{version}.jar
%{libdir}/tomcat-tomcat-util-scan.jar              
%{libdir}/tomcat-tomcat-util-scan-%{version}.jar              
%{libdir}/tomcat-tomcat-jni.jar                               
%{libdir}/tomcat-tomcat-jni-%{version}.jar       
%{libdir}/tomcat-tomcat-dbcp.jar                               
%{libdir}/tomcat-tomcat-dbcp-%{version}.jar       
%{libdir}/tomcat-catalina-storeconfig.jar                               
%{libdir}/tomcat-catalina-storeconfig-%{version}.jar                               
%{_javadir}/%{name}-tomcat-juli-%{version}.jar
%else
# Assume RHEL-7
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/JPP.%{name}-jsp-api.pom
%{_mavenpomdir}/JPP.%{name}-servlet-api.pom
%{_mavenpomdir}/JPP.%{name}-el-api.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-coyote.pom
%{_mavenpomdir}/JPP.%{name}-catalina.pom
%{_mavenpomdir}/JPP.%{name}-jasper-el.pom
%{_mavenpomdir}/JPP.%{name}-jasper.pom
%{_mavenpomdir}/JPP.%{name}-annotations-api.pom
%{_mavenpomdir}/JPP.%{name}-catalina-ant.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-fr.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-es.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-i18n-ja.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-jdbc.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-util.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-api.pom
# tomcat-extras-juli-adapters
#        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli-adapters.pom
# tomcat-extras-juli
#        %{buildroot}%{_mavenpomdir}/JPP.%{name}-tomcat-extras-juli.pom
%{_mavenpomdir}/JPP.%{name}-websocket-api.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-websocket.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-util-scan.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-jni.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-dbcp.pom
%{_mavenpomdir}/JPP.%{name}-catalina-storeconfig.pom
# embed poms
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-core.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-jasper.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-logging-juli.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-websocket.pom
%{_mavenpomdir}/JPP.%{name}-tomcat-embed-el.pom
%endif
# embed jars
%{libdir}/tomcat-embed-core.jar
%{libdir}/tomcat-embed-core-%{version}.jar
%{libdir}/tomcat-embed-jasper.jar
%{libdir}/tomcat-embed-jasper-%{version}.jar
%{libdir}/tomcat-embed-logging-juli.jar
%{libdir}/tomcat-embed-logging-juli-%{version}.jar
%{libdir}/tomcat-embed-websocket.jar
%{libdir}/tomcat-embed-websocket-%{version}.jar
%{libdir}/tomcat-embed-el.jar
%{libdir}/tomcat-embed-el-%{version}.jar

%files el-%{elspec}-api
%defattr(0644,root,root,0755)
#%if 0%{?rhel} == 6
%{_javadir}/%{name}-el-%{elspec}-api-%{version}.jar
%{_javadir}/%{name}-el-%{elspec}-api.jar
#%endif
%{libdir}/el-api.jar
%{libdir}/el-api-%{version}.jar
%ghost %{_javadir}*/el_%{elspecalt}_api.jar
%ghost %{_javadir}*/el-api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files jsp-%{jspspec}-api
%defattr(0644,root,root,0755)
#%if 0%{?rhel} == 6
%{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar
%{_javadir}/%{name}-jsp-%{jspspec}-api.jar
#%endif
%{libdir}/jsp-api.jar
%{libdir}/jsp-api-%{version}.jar
%ghost %{_javadir}*/jsp-api.jar

%files log4j
%defattr(0640,root,root,0750)
%attr(0640,root,tomcat) %config(noreplace) %{confdir}/log4j.properties
%{libdir}/log4j.properties
%{libdir}/log4j-eap6.jar

%files lib
%defattr(0644,root,root,0755)
%dir %{libdir}
%{libdir}/annotations-api.jar
%{libdir}/annotations-api-%{version}.jar
%{libdir}/catalina.jar
%{libdir}/catalina-%{version}.jar
%{libdir}/catalina-ant.jar
%{libdir}/catalina-ant-%{version}.jar
%{libdir}/tomcat-jdbc.jar
%{libdir}/tomcat-jdbc-%{version}.jar
%{libdir}/tomcat-util.jar
%{libdir}/tomcat-util-%{version}.jar
%{libdir}/tomcat-api.jar
%{libdir}/tomcat-api-%{version}.jar
%{libdir}/ecj-%{ecjrev}-eap6.jar
%{libdir}/jasper.jar
%{libdir}/jasper-%{version}.jar
%{libdir}/jasper-el.jar
%{libdir}/jasper-el-%{version}.jar
%{libdir}/tomcat-coyote.jar
%{libdir}/tomcat-coyote-%{version}.jar
%{libdir}/tomcat-i18n-es.jar
%{libdir}/tomcat-i18n-es-%{version}.jar
%{libdir}/tomcat-i18n-fr.jar
%{libdir}/tomcat-i18n-fr-%{version}.jar
%{libdir}/tomcat-i18n-ja.jar
%{libdir}/tomcat-i18n-ja-%{version}.jar
%{libdir}/websocket-api.jar
%{libdir}/websocket-api-%{version}.jar
%{libdir}/tomcat-websocket.jar
%{libdir}/tomcat-websocket-%{version}.jar
%{libdir}/tomcat-util-scan.jar
%{libdir}/tomcat-util-scan-%{version}.jar
%{libdir}/catalina-storeconfig.jar
%{libdir}/catalina-storeconfig-%{version}.jar
%{libdir}/tomcat-jni.jar
%{libdir}/tomcat-jni-%{version}.jar
%{libdir}/tomcat-dbcp.jar
%{libdir}/tomcat-dbcp-%{version}.jar
%{libdir}/commons-collections-eap6.jar
# %{libdir}/commons-logging-api-eap6.jar
# %{libdir}/commons-logging-adapters-eap6.jar
%{libdir}/extras/tomcat-juli-adapters.jar
%{libdir}/extras/tomcat-juli-adapters-%{version}.jar
%{libdir}/extras/tomcat-juli.jar
%{libdir}/extras/tomcat-juli-%{version}.jar
%if 0%{?rhel} == 6
%{_javadir}/%{name}-annotations-api-%{version}.jar
%{_javadir}/%{name}-catalina-%{version}.jar
%{_javadir}/%{name}-catalina-ant-%{version}.jar
%{_javadir}/%{name}-tomcat-jdbc-%{version}.jar
%{_javadir}/%{name}-tomcat-util-%{version}.jar
%{_javadir}/%{name}-tomcat-api-%{version}.jar
%{_javadir}/%{name}-jasper-%{version}.jar
%{_javadir}/%{name}-jasper-el-%{version}.jar
%{_javadir}/%{name}-tomcat-i18n-es-%{version}.jar
%{_javadir}/%{name}-tomcat-i18n-fr-%{version}.jar
%{_javadir}/%{name}-tomcat-i18n-ja-%{version}.jar
%{_javadir}/%{name}-websocket-api-%{version}.jar
%{_javadir}/%{name}-tomcat-dbcp-%{version}.jar
%{_javadir}/%{name}-tomcat-jni-%{version}.jar
%{_javadir}/%{name}-catalina-storeconfig-%{version}.jar
%{_javadir}/%{name}-tomcat-util-scan-%{version}.jar
%{_javadir}/%{name}-tomcat-websocket-%{version}.jar
%{_javadir}/%{name}-tomcat-coyote-%{version}.jar
%endif

%files servlet-%{servletspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
%{_javadir}/%{name}-servlet-%{servletspec}-api.jar
%{libdir}/servlet-api.jar
%{libdir}/servlet-api-%{version}.jar
%ghost %{_javadir}/servlet-api.jar

%if %with zips
%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/tomcat8-%{version}.zip
%{_javadir}*/jbossas-fordev/tomcat8-%{version}-examples.zip
%{_javadir}*/jbossas-fordev/tomcat8-%{version}-embed.zip
#%{_javadir}*/jbossas-fordev/tomcat8-%{version}-maven-devel.zip

%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}*/jbossas-fordev
%{_javadir}*/jbossas-fordev/tomcat8-%{version}-src.zip
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%files jsvc
%defattr(755,root,root,0755)
%if 0%{?rhel} >= 7
    %attr(0644,root,root) %{_unitdir}/%{name}-jsvc.service
    %attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
    %attr(0640,tomcat,tomcat) %{logdir}/catalina.out
%else
    %{_sbindir}/%{name}-jsvc
%endif

%files selinux
%defattr(-,root,root,-)
%{_datadir}/selinux/packages/%{name}/%{name}.pp
%doc selinux/*

%changelog
* Thu May 21 2020 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-44
- Resolves: CVE-2020-9484 tomcat: Apache Tomcat Remote Code Execution via session persistence

* Tue Mar 03 2020 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-42
- Related: JWS-1586 Revert default changes for AJP bind address and secretRequired

* Tue Feb 25 2020 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-41
- Resolves: JWS-1580 CVE-2019-0221 tomcat: XSS in SSI printenv
- Resolves: JWS-1586 CVE-2020-1938 ajp: tomcat: Apache Tomcat AJP File Read/Inclusion Vulnerability

* Thu Jan 30 2020 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-40
- Resolves: JWS-1501 CVE-2019-12418 tomcat: local privilege escalation
- Resolves: JWS-1506 CVE-2019-17563 tomcat: session fixation

* Fri Jun 21 2019 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-39
- Resolves: JWS-1411 Tomcat does not start with LoadExternalPropertiesListener

* Thu Jun 20 2019 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-38
- Resolves: JWS-1414 Tomcat frequently hangs at startup when Jolokia loads certificate

* Fri May 31 2019 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-37
- Resolves: JWS-1303 Body text property replacement fails
- Resolves: JWS-1372 CVE-2019-0232 Remote Code Execution on Windows

* Fri Apr 26 2019 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-36
- Resolves: JWS-1365 Provide JMX listener to enable and configure JMX remote

* Wed Nov 14 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-35
- Resolves: JWS-1278 CVE-2018-11784 tomcat: Avoid protocol relative redirects in default servlet

* Wed Oct 17 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-34
- Resolves: JWS-1095 CVE-2018-8034 tomcat8: tomcat: host name verification missing in WebSocket client

* Tue Aug 21 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-32
- Resolves: JWS-1093 CVE-2018-1336 tomcat7: tomcat: A bug in the UTF-8 decoder can lead to DoS

* Tue Jul 03 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-31
- Resolves: JWS-1027 CVE-2018-8014 tomcat: Insecure defaults in CORS filter enable 'supportsCredentials' for all origins

* Mon Mar 26 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-30
- Resolves: JWS-931 Add system property expansion support for properties files
- Resolves: JWS-949 remove or change RPM preamble's commons-dameon classpath entry

* Thu Feb 08 2018 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-29
- Build for JWS_3.1.0.SP2.ER1
- Resolves: JWS-905 CVE-2018-1304 tomcat: Security constraints mapped to context root are ignored
- Resolves: JWS-906 CVE-2018-1305 tomcat: Security constraint annotations applied too late

* Mon Dec 18 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-28
- Build for JWS_3.1.0.SP2.DR2
- Resolves: JWS-211 Java 9 support for Tomcat 8
- Resolves: JWS-863 Enable the configuration of multiple properties files

* Thu Nov 30 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-27
- Build for JWS_3.1.0.SP2.DR1
- Resolves: JWS-847 Allow system property value replacement from the digester property source
- Resolves: JWS-832 Backport 60391 for Tomcat 8
- Resolves: JWS-828 CVE-2017-12617 tomcat: JSP upload
- Resolves: JWS-821 Allow subclassing of org.apache.catalina.filters.CorsFilter
- Resolves: JWS-783 tomcat fails to start via tomcat-jsvc service startup due to selinux denials
- Resolves: JWS-831 Port BZ1208402 to JWS 3.1 tomcats
- Resolves: JWS-799 CVE-2017-12615 CVE-2017-12616 tomcat: File path validation fix

* Thu Jul 06 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-24
- Resolves: JWS-759 CVE-2017-5645 log4j: Socket receiver deserialization vulnerability

* Wed Jun 28 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-23
- Build for JWS_3.1.0.SP1.ER1
- Related: JWS-695 The old policy at priority 400 should be removed before installing
- Resolves: JWS-721 CVE-2017-7674 tomcat: CORS filter Vary header missing
- Resolves: JWS-741 Configurations in conf.d are not applied
- Resolves: JWS-760 Provide an option to enable/disable processing of Class-Path entry in a jar's manifest file

* Tue Jun 06 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-20
- Related: JWS-695 Correcting policy issues with rhel-6 which prevented tomcat from starting

* Mon Jun 05 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-19
- Related: JWS-695 Correcting a typo in the selinux policy

* Tue May 30 2017 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-18
- Build for JWS_3.1.0.SP1.DR1
- Resolves: JWS-668 CVE-2017-5648 tomcat: Ensure request and response facades are used when firing application listeners
- Resolves: JWS-701 CVE-2017-5647 tomcat: Sendfile pipelining improvements
- Resolves: JWS-714 CVE-2017-5664 tomcat: Error page processing fix
- Resolves: JWS-695 tomcat7_t and tomcat8_t domains are in unconfined_domain
- Resolves: JWS-709 RPM missing selinux-policy dependency
- Resolves: JWS-725 /usr/share/tomcat7 needs world execute permissions to function on openshift v2

* Thu Dec 08 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-17
- Build for JWS_3.1.0.CR3
- Related: JWS-500 CVE-2016-6797 When adding and removing ResourceLinks dynamically, ensure that the global resource is only visible via the ResourceLinkFactory when it is meant to be
- Resolves: JWS-619 CVE-2016-8745 Sendfile socket closing with NIO connector

* Tue Nov 08 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-12
- Resolves: JWS-595 Add sources JARs to satsify Maven Repository Requirements

* Thu Nov 03 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-10
- Resolves: JWS-572 Possible async deadlocks
- Resolves: JWS-577 CVE-2016-6816 Additional checks for valid characters to the HTTP request line
- Resolves: JWS-578 CVE-2016-8735 Explicitly configure allowed credential types

* Wed Nov 02 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-9
- Resolves: JWS-567 CVE-2016-0762 Make timing attacks against the Realm implementations harder
- Resolves: JWS-568 CVE-2016-6796 Ignore some JSP options when running under a SecurityManager
- Resolves: JWS-569 CVE-2016-5018 Security Manager Bypass in JSP
- Resolves: JWS-570 HTTP parser improvements
- Resolves: JWS-571 Jasper fails to initialize when running with SecurityManager enabled

* Wed Oct 05 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-8
- Resolves: JWS-559 RHEL6 RPM: Stop shipping tomcat-juli maven artifacts in the main tomcat package

* Wed Sep 14 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-7
- Resolves: JWS-521 Add JSVC script to tomcat distribution
- Resolves: JWS-522 RHEL7 RPM: catalina.out is no longer in use, but still gets rotated
- Resolves: JWS-516 RHEL6 RPM: /usr/sbin/tomcat7 and /usr/sbin/tomcat8 don't work
- Resolves: JWS-530 Update selinux policy files for tomcat and add selinux subpackage
- Resolves: JWS-542 Add embedded jars to maven repository
- Resolves: JWS-538 RHEL6 RPM: CVE-2016-1240 tomcat: unsafe chown of catalina.log in tomcat init script allows privilege escalation

* Thu Sep 08 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-6
- Resolves: JWS-494
- Resolves: JWS-511 apache-commons-daemon update to JBCS distribution
- Resolves: JWS-513 RHEL6 RPM: Correct dependency on redhat-lsb
- Resolves: JWS-514 RHEL6 RPM: tomcat wrapper script CLASSPATH eror can cause a hang in the annotations scanning of deployments
- Resolves: JWS-515 After moving to systemd units, catalina.out is no longer in use

* Wed Aug 24 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-2
- Resolves: JWS-490 CVE-2016-6325 tomcat: tomcat writable config files allow privilege escalation
- Resolves: JWS-498 CVE-2016-6794 Provide a mechanism that enables the container to check if a component has been granted a given permission

* Mon Jul 11 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.36-1
- Resolves: JWS-293 Remove webapps/examples
- Resolves: JWS-472 The security manager doesn't work correctly
- Resolves: JWS-470 Confusing service status output for tomcat7 and tomcat8 installed both on RHEL system
- Resolves: JWS-409 commons-logging-tomcat-juli.jar in JWS 3 /usr/sbin/tomcat8
- Resolves: JWS-401 Tomcat does not properly parse spaces in JVM parameters/settings
- Resolves: JWS-399 LOGGING_CONFIG always set to logging.properties in RPM
- Resolves: JWS-80 JPP pom files in RPM installation
- Resolves: JWS3-40 replace init scripts for tomcat7 and 8 on RHEL7 by systemd units

* Fri Apr 01 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-61_patch_01
- Build for JWS_3.0.3.CR1

* Fri Mar 04 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-60_patch_01
- Build for JWS_3.0.3.ER1

* Mon Feb 8 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-59_patch_01
- Resolves: JWS-344 Adding tomcat.xsd to RPM distribution

* Wed Jan 27 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-58_patch_01
- Build for JWS_3.0.3.DR2

* Thu Jan 14 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-57_patch_01
- Rebuild JWS_3.0.3.DR1

* Wed Jan 13 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-56_patch_01
- Resolves: JWS-314 Completely removing examples webapps

* Tue Jan 12 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-55_patch_01
- Build for JWS_3.0.3.DR1

* Tue Jan 05 2016 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-54_patch_01
- Converting sources from patching model to git. Removed all patch files from spec
  and added new source to be updated for each build/release.

* Wed Dec 09 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-53_patch_01
- Related: JWS-272. Added revision to resolve problem with initial patch.

* Tue Dec 01 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-53_patch_01
- Resolves: JWS-285

* Fri Nov 20 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-53_patch_01
- Resolves: JWS-277

* Wed Nov 18 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-52_patch_01
- Adding dependency on specific commons-collections build for rhbz-1283059

* Wed Nov 18 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-52_patch_01
- Resolves: JWS-273

* Wed Nov 18 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-52_patch_01
- Resolves: JWS-272

* Tue Nov 10 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-51_patch_01
- Resolves: JWS-190. Config only (tomcat8-8.0.init) update.

* Fri Nov 6 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-51_patch_01
- Resolves: JWS-264

* Fri Nov 6 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-51_patch_01
- Resolves: JWS-161

* Mon Oct 26 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-50_patch_01
- Related: JWS-192. proposed fix was insufficient.

* Mon Oct 26 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-49_patch_01
- Rebuilding for release.

* Fri Oct 23 2015 David Knox <dknox@redhat.com> 0:8.0.18-48_patch_01
- Synchronize the release number between changelog and Release

* Tue Oct 20 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-47_patch_01
- Resolves: JWS-172

* Tue Oct 13 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-46_patch_01
- Resolves: JWS-140

* Thu Oct 8 2015 David Knox <dknox@redhat.com> 0:8.0.18-45_patch_01
- Resolves: typo in init file. increment release.

* Thu Oct 8 2015 David Knox <dknox@redhat.com> 0:8.0.18-44_patch_01
- Resolves: JWS-240

* Wed Oct 7 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-43_patch_00
- Resolves: JWS-242

* Tue Oct 6 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-43_patch_00
- Resolves: JWS-171

* Mon Oct 5 2015 Coty Sutherland <csutherl@redhat.com> 0:8.0.18-42_patch_00
- Resolves: JWS-170

* Thu Oct 1 2015 David Knox <dknox@redhat.com> 0:8.0.18-41_patch_00
- Resolves: JWS-154

* Thu Oct 1 2015 David Knox <dknox@redhat.com> 0:8.0.18-40_patch_00
- Related: JWS-189

* Wed Sep 30 2015 David Knox <dknox@redhat.com> 0:8.0.18-39_patch_00
- Edit tomcat8-8.0.12-jbpapp-6122-jon.patch edited instances of the
- word tomcat6
- log_message_msg stopped working

* Tue Sep 29 2015 David Knox <dknox@redhat.com> 0:8.0.18-38_patch_00
- Resolves: JWS-128

* Tue Sep 29 2015 David Knox <dknox@redhat.com> 0:8.0.18-37_patch_00
- Resolves: JWS-192 Edit in tomcat8-8.0.init

* Tue Sep 29 2015 David Knox <dknox@redhat.com> 0:8.0.18-36_patch_00
- Resolves: JWS-85

* Mon Sep 28 2015 David Knox <dknox@redhat.com> 0:8.0.18-35_patch_00
- Resolves: JWS-191

* Mon Sep 28 2015 David Knox <dknox@redhat.com> 0:8.0.18-34_patch_00
- Resolves: JWS-196 Instances of tomcat6 found in tomcat8.conf and
- tomcat8-8.0-tool-wrapper.script. 

* Thu Sep 24 2015 David Knox <dknox@redhat.com> 0:8.0.18-33_patch_00
- Resolve: JWS-232 obsolete digest script

* Thu Sep 17 2015 David Knox <dknox@redhat.com> 0:8.0.18-32_patch_00
- Updated spec file to apply jws-163 and jws-143

* Wed Sep 16 2015 David Knox <dknox@redhat.com> 0:8.0.18-31_patch_00
- Resolves: JWS-163 JWS-143

* Tue Aug 25 2015 David Knox <dknox@redhat.com> 0:8.0.18-30_patch_00
- Related: JWS-168 includes JWS-144. new patch generated.

* Tue Aug 18 2015 David Knox <dknox@redhat.com> 0:8.0.18-29_patch_00
- Resolves: JWS-168

* Mon Aug 17 2015 David Knox <dknox@redhat.com> 0:8.0.18-28_patch_00
- Related: JWS-84 Resolves: JWS-167

* Thu Aug 13 2015 David Knox <dknox@redhat.com> 0:8.0.18-27_patch_00
- Related: JWS-189

* Tue Aug 11 2015 David Knox <dknox@redhat.com> 0:8.0.18-26_patch_00
- Resolves: JWS-189

* Tue Aug 11 2015 David Knox <dknox@redhat.com> 0:8.0.18-25_patch_00
- Resolves: JWS-141 JWS-142

* Wed Aug 5 2015 David Knox <dknox@redhat.com> 0:8.0.18-24_patch_00
- Resolves: JWS-164 JWS-165

* Wed Aug 5 2015 David Knox <dknox@redhat.com> 0:8.0.18-23_patch_00
- Resolves: JWS-162 JWS-160

* Wed Aug 5 2015 David Knox <dknox@redhat.com> 0:8.0.18-22_patch_00
- Resolves: JWS-137

* Mon Jul 13 2015 David Knox <dknox@redhat.com> 0:8.0.18-21_patch_00
- Resolves: JWS-166

* Tue Jun 30 2015 David Knox <dknox@redhat.com> 0:8.0.18-20_patch_00
- rhel-6 was still broken. releng ticket 359371. 
- bumping the release number

* Tue Jun 30 2015 David Knox <dknox@redhat.com> 0:8.0.18-19_patch_00
- rhel-7 build worked. rhel-6 build was broken, releng ticket
- 359371. bumping the release number

* Tue Jun 30 2015 David Knox <dknox@redhat.com> 0:8.0.18-18_patch_00
- Last build was the wrong commit. bumping the release number for
- a new build

* Sun Jun 28 2015 David Knox <dknox@redhat.com> 0:8.0.18-17_patch_00
- Resolves: JWS-138
- Resolves: JSW-139

* Wed May 20 2015 David Knox <dknox@redhat.com> 0:8.0.18-16_patch_00
- Resolves: JWS-84 disable log rotation

* Tue Apr 28 2015 David Knox <dknox@redhat.com> 0:8.0.18-15_patch_00
- Resolves: JWS-96 build-classpath error. fixed in wrapper.
- removed build-classpath as it isn't necessary any more.
- the problem still exists in java-functions

* Tue Apr 14 2015 David Knox <dknox@redhat.com> 0:8.0.18-14
- Resolves: JWS-69 rework. fixed broken symlinks for catalina and
- websocket-api

* Wed Apr 8 2015 David Knox <dknox@redhat.com> 0:8.0.18-13
- Resolves: JWS-69 TPS Delete test FAILED

* Tue Apr 7 2015 David Knox <dknox@redhat.com> 0:8.0.18-12
- Resolves: JWS-70 log4j in binary zip did not conform to
- eap6 name convention. the name must be log4j-eap6

* Wed Apr 1 2015 David Knox <dknox@redhat.com> 0:8.0.18-11
- Resolves: JWS-51 Add storeconfig pom temporarily.
- Add storeconfig to maven depmap both el-6 and el-7
- Remove maven-devel zip from the zip distribution. 
- Remove embed-el pom
  
* Fri Mar 20 2015 David Knox <dknox@redhat.com> 0:8.0.18-10
- Commented BR & R for commons-logging imports. Not needed
- anymore.

* Thu Mar 19 2015 David Knox <dknox@redhat.com> 0:8.0.18-9
- add_maven_depmap for rhel-7
- fix copy to symlink for eap6 libs for the rpms
- remove rhel-6 restriction from update_maven_depmap

* Mon Mar 16 2015 David Knox <dknox@redhat.com> 0:8.0.18-6
- Resolves: JWS-58 remove commons-logging 1.1.3 from extras
- Fix sources, exclude older src packages

* Wed Mar 11 2015 David Knox <dknox@redhat.com> 0:8.0.18-5_patch_00
- Resovles: JWS-56 missing jars: commons-logging-adapters.jar and 
- commons-logging-api.jar
- Made references to commons libs consistant. commons-*-eap6 and
- commons-*-tomcat-eap6
- Include commons-logging-adapters-1.1.3 jar in extras. It was
- always built but not included in packaging.

* Tue Mar 10 2015 David Knox <dknox@redhat.com> 0:8.0.18-4_patch_00
- Corrected ecjrev to 4.4.2. Changed BR and R for commons-collections
- to commons-collections-tomcat-eap6

* Thu Mar 5 2015 David Knox <dknox@redhat.com> 0:8.0.18-3_patch_00
- Unified rhel-6 & 7 builds. Added ecj 4.4

* Tue Feb 10 2015 David Knox <dknox@redhat.com> 0:8.0.18-3_patch_00
- Resolves: rhbz 1190063 remove storeconfig ha and cluster
- dependencies

* Mon Feb 9 2015 David Knox <dknox@redhat.com> 0:8.0.18-2_patch_00
- increment release. building to make sure both targets still 
- build correctly

* Thu Feb 5 2015 David Knox <dknox@redhat.com> 0:8.0.18-0_patch_00
- Update to 8.0.18

- Using target=jws-3.0-rhel-6-candidate works now. All builds
- should be done on the rhel-7 branch. the rhel-6 branch will
- be abandoned

* Wed Feb 4 2015 David Knox <dknox@redhat.com> 0:8.0.17-4_patch_00
- Increment release number to match the rhel-6 build. We no longer
- build rhel-6. Instead use --target to build for rhel-6.

* Wed Feb 4 2015 David Knox <dknox@redhat.com> 0:8.0.17-2_patch_00
- Add maven-devel zip

* Tue Feb 3 2015 David Knox <dknox@redhat.com> 0:8.0.17-1_patch_00
- Resolves: change commons-collections-tomcat-eap6 to 
- commons-collections-eap6. change commons-daemon and commons-logging
- to commons-daemon-eap6 and commons-logging-eap6. change ecj to
- ecj-eap6. Now both rhel-7 and rhel-6 use the same dependency names

* Tue Jan 20 2015 David Knox <dknox@redhat.com> 0:8.0.17-0_patch_00
- rebase to 8.0.17

* Tue Jan 13 2015 Jean-Frederic Clere <jclere@redhat.com> 0:8.0.15-5_patch_00
- Resolves: rhbz 1173186  tomcat8/webapps/examples/WEB-INF/classes has no compiled classes

* Tue Dec 23 2014 Jean-Frederic Clere <jclere@redhat.com> 0:8.0.15-4_patch_00
- Resolves: rhbz 1175635 Missing package org.apache.tomcat.dbcp.dbcp2 in Tomcat 8 library

* Tue Dec 16 2014 Maxime Beck <maxbeck@redhat.com> 0:8.0.15-3_patch_00
- Resolves: rhbz 1173878 tc8 el7 zip name error

* Wed Dec 10 2014 David Knox <dknox@redhat.com> 0:8.0.15-2_patch_00
- Rebase to tomcat8-8.0.15. Added new poms to distro

* Fri Sep 5 2014 David Knox <dknox@redhat.com> 0:8.0.12-1_patch_00
- First import
